@echo OFF
@if not "%ECHO%"=="" echo %ECHO%
@if not "%OS%"=="Windows_NT" goto DOSEXIT
rem $Workfile: pjcount.bat $ $Revision: 1 $ $Date: 12/04/97 9:51a $
rem $Archive: /TimH/Pubs/Books/Macmillan/Windows NT Scripting/Scripts/pjcount.bat $

rem Set local scope and call MAIN procedure
setlocal & pushd & set RET=
	set SCRIPTNAME=%~n0
	set SCRIPTPATH=%~f0
	if "%DEBUG%"=="1" (set TRACE=echo) else (set TRACE=rem)
	call _mtplib :INIT %SCRIPTPATH%
	if /i {%1}=={/help} (call :HELP %2) & (goto :HELPEXIT)
	if /i {%1}=={/?} (call :HELP %2) & (goto :HELPEXIT)
	call :MAIN %*
	:HELPEXIT
popd & endlocal & set RET=%RET%
goto :EOF

rem /////////////////////////////////////////////////////////////////////////
rem HELP procedure
rem Display brief on-line help message
rem
:HELP
if defined TRACE %TRACE% [proc %0 %*]
	echo Syntax: PJCOUNT [computer]
	echo Collate and count print jobs per user.
	echo .
	echo Counts print jobs and pages for each user, using event log
	echo of specified or local computer.
goto :EOF

rem /////////////////////////////////////////////////////////////////////////
rem MAIN procedure
rem
:MAIN
if defined TRACE %TRACE% [proc %0 %*]
	if not {%1}=={} (set COMPUTER=/S %1) else (set COMPUTER=)
	set USERNAME=
	echo Username                       Jobs     Pages    Bytes
	echo ------------------------------ -------- -------- ------------
	for /f "tokens=*" %%I in ('dumpel /l system %COMPUTER% /e 10 /m Print /format "us" 2^>nul ^| sort') do call :SCANJOB %%I
	call :SHOWUSERINFO
goto :EOF

rem /////////////////////////////////////////////////////////////////////////
rem SCANJOB procedure
rem Collate information from one print job
rem
rem Arguments:	%1=username (sorted)
rem		%n=rest of arguments
rem
:SCANJOB
if defined TRACE %TRACE% [proc %0 %*]
	rem Handle switch to new username
	if not {%1}=={%USERNAME%} (
		(call :SHOWUSERINFO)
		(set USERNAME=%1)
		(set /a JOBCOUNT=0)
		(set /a PAGECOUNT=0)
		(set /a BYTECOUNT=0)
	)
	
	set /a JOBCOUNT+=1
	:SCANJOBLOOP
		if {%2}=={} goto :SCANJOBLOOPEND
		if /i {%2}=={bytes:} set /a BYTECOUNT+=%3
		if /i {%2}=={printed:} set /a PAGECOUNT+=%3
		shift /2
	goto :SCANJOBLOOP
	:SCANJOBLOOPEND
goto :EOF

rem /////////////////////////////////////////////////////////////////////////
rem SHOWUSERINFO procedure
rem Display accumulated results for one user
rem
rem Arguments:	USERNAME=user name
rem		JOBCOUNT=job count
rem		PAGECOUNT=page count
rem		BYTECOUNT=byte count
rem
:SHOWUSERINFO
if defined TRACE %TRACE% [proc %0 %*]
	if "%USERNAME%"=="" goto :EOF

	rem The following SET commands are all space-padded to here ------->
	set T1=%USERNAME%                                                   
	set T2=%JOBCOUNT%                                                   
	set T3=%PAGECOUNT%                                                  
	set T4=%BYTECOUNT%
	
	rem Do not pad these SET commands                                                  
	set T1=%T1:~0,30%
	set T2=%T2:~0,8%
	set T3=%T3:~0,8%
	set T4=%T4:~0,12%
	echo %T1% %T2% %T3% %T4%
goto :EOF

rem /////////////////////////////////////////////////////////////////////////
rem Additional procedures go here...

rem These must be the FINAL LINES in the script...
:DOSEXIT
echo This script requires Windows NT

rem /////////////////////////////////////////////////////////////////////////
